SystemOrganization addCategory: #'PharoBot-UI'!

TransformationMorph subclass: #RobotMorph
	instanceVariableNames: 'mundo direccion estado_pincelArriba estado_pincelAbajo estado_pincelActual ultimaPosicion bateria'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!RobotMorph class methodsFor: 'crear instancia' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
"Luego de crear un robot hay que mandarle el mensaje 'inicializarRobot' "

crearRobotConMundo: unMundo conBateria: unaBateria

|nuevoRobot|

nuevoRobot:= self new.
nuevoRobot mundo: unMundo.
nuevoRobot bateria: unaBateria.
unMundo robot: nuevoRobot.
nuevoRobot position: (nuevoRobot mundo position x + (nuevoRobot mundo extent x / 2) ) @ (nuevoRobot mundo position y + (nuevoRobot mundo extent y / 2)).
^ nuevoRobot openInWorld .
! !

!RobotMorph methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
bajarPincel

self estado_pincelActual: self estado_pincelAbajo.! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
bateria
	^ bateria! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
bateria: anObject
	bateria := anObject! !

!RobotMorph methodsFor: 'caminos' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
borrarCaminos

self mundo caminos do:  [:elem | elem delete.].
self mundo caminos: Set new.! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
direccion
	^ self angle radiansToDegrees .! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
direccion: unAngulo
	self angle: unAngulo degreesToRadians.
	self position: self ultimaPosicion .
! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
estado_pincelAbajo
	^ estado_pincelAbajo! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
estado_pincelAbajo: anObject
	estado_pincelAbajo := anObject! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
estado_pincelActual
	^ estado_pincelActual! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
estado_pincelActual: anObject
	estado_pincelActual := anObject! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
estado_pincelArriba
	^ estado_pincelArriba! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
estado_pincelArriba: anObject
	estado_pincelArriba := anObject! !

!RobotMorph methodsFor: 'inicializar' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
inicializarRobot

|piezaUno piezaDos piezaTres piezaCuatro piezaCinco pixel posInicial|
"Cuerpo"
piezaUno:= BorderedMorph new.
piezaUno extent: 20@40.
piezaUno color: (Color lightGreen  ).
piezaUno borderColor: Color green.
piezaUno openInWorld .
piezaUno position: self position. 
self asFlexOf: piezaUno.

"Ojo izquierdo"
piezaDos:= CircleMorph new.
piezaDos extent: 10@10.
piezaDos color: (Color blue alpha: 0.5).
piezaDos position: (piezaUno position x + 7) @ (piezaUno position y + 5).
piezaDos openInWorld .
piezaUno addMorph: piezaDos.

"Ojo derecho"
piezaTres:= CircleMorph new.
piezaTres extent: 10@10.
piezaTres color: (Color blue alpha: 0.5).
piezaTres position: (piezaUno position x + 7) @ (piezaUno position y + 23).
piezaTres openInWorld .
piezaUno addMorph: piezaTres.

"Bolita del ojo 1"
piezaCuatro:= CircleMorph new.
piezaCuatro extent: 5@5.
piezaCuatro color: Color black .
piezaCuatro position: (piezaDos position x + 5) @ (piezaDos position y + 3) .
piezaCuatro openInWorld .
piezaDos addMorph: piezaCuatro.

"Bolita del ojo 2"
piezaCinco:= CircleMorph new.
piezaCinco extent: 5@5.
piezaCinco color: Color black .
piezaCinco position: (piezaTres position x + 5) @ (piezaTres position y + 3) .
piezaCinco openInWorld .
piezaTres addMorph: piezaCinco.

"Cuerpo del robot "

posInicial:= (piezaUno position x + 20) @ (piezaUno position y).

(8)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x + 2) @ (posInicial y + 2.5).].

posInicial:= (piezaUno position x + 20) @ (piezaUno position y + 37).

(8)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x + 2) @ (posInicial y - 2.5).].

" Brazos del robot  y pincel"

posInicial:= (piezaUno position x + 26) @ (piezaUno position y + 6).

(8)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x - 1) @ (posInicial y - 2.5).].

posInicial:= (piezaUno position x + 26) @ (piezaUno position y + 31).

(8)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x - 1) @ (posInicial y + 2.5).].

"Pies"

posInicial:= (piezaUno position x + 37) @ (piezaUno position y + 17).
(4)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x + 2) @ (posInicial y - 2).].

posInicial:= (piezaUno position x + 37) @ (piezaUno position y + 17).
(4)timesRepeat: 
[pixel:= Morph new.
pixel extent: 2@2.
pixel position: posInicial.
pixel color: Color green .
pixel openInWorld .
piezaUno addMorph: pixel.
posInicial:= (posInicial x + 2) @ (posInicial y + 2).].

self ultimaPosicion: self position.

"Se une el robot con su mundo"
self mundo addMorph: self.


! !

!RobotMorph methodsFor: 'movimiento' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
mover: unaLongitud 

self estado_pincelActual mover: unaLongitud.! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
mundo
	^ mundo! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
mundo: anObject
	mundo := anObject! !

!RobotMorph methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelAbajo 

^ self estado_pincelActual pincelAbajo .! !

!RobotMorph methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelArriba  

^ self estado_pincelActual pincelArriba .! !

!RobotMorph methodsFor: 'inicializar' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
reasignarRobot 

"Se une el robot con su mundo"
self mundo addMorph: self.! !

!RobotMorph methodsFor: 'bateria' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
recargarBateria

self bateria recargar .! !

!RobotMorph methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
subirPincel

self estado_pincelActual: self estado_pincelArriba .! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
ultimaPosicion
	^ ultimaPosicion! !

!RobotMorph methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
ultimaPosicion: anObject
	ultimaPosicion := anObject! !

Morph subclass: #Mundo
	instanceVariableNames: 'robot caminos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!Mundo class methodsFor: 'crear instancia' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
"El tamao es pasado de la siguiente manera    140 @ 140 donde los valores de X e Y deben ser multiplos de 70"

crearMundo: unaSuperficie

|mundo nroRepeticionesEnX nroRepeticionesEnY posicionActual cuadriculaNueva|

"Chequear datos ingresados"

((unaSuperficie x isDivisibleBy: 70) & (unaSuperficie y isDivisibleBy: 70))
ifFalse: [ self error: 'Los valores ingresados deben ser multiplos de 70'].

mundo:= self new.
mundo color: (Color black alpha: 0.3).
mundo extent: unaSuperficie.

"Cuadriculado"

nroRepeticionesEnX:= mundo extent x // 70.
nroRepeticionesEnY:= mundo extent y // 70.
posicionActual:= mundo position.

(nroRepeticionesEnY) timesRepeat: 
[(nroRepeticionesEnX) timesRepeat: [ cuadriculaNueva:= CuadriculaDeMundo crearCuadriculaDeMundo.	
								cuadriculaNueva position: posicionActual.
								mundo addMorph: cuadriculaNueva.
								posicionActual:= (posicionActual x + 70) @ (posicionActual y)].
							
	posicionActual:= (posicionActual x - (nroRepeticionesEnX * 70) @ (posicionActual y + 70)) ].

mundo caminos: Set new.

^ mundo! !

!Mundo methodsFor: 'caminos' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
actualizarCaminos: unMundoNuevo

self caminos do: [ :punto | unMundoNuevo addMorph: punto.].
self caminos do: [ :punto | unMundoNuevo caminos add: punto.]! !

!Mundo methodsFor: 'extenciones' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
ampliarParaMoverEnX: unaLongitud delRobot: unRobot

((unRobot left - unRobot mundo left)abs <= unaLongitud)
"Se extiende al oeste"
ifTrue: [ self extenderAlOeste: unaLongitud.
		self robot reasignarRobot .] .

(((unRobot left + unRobot extent x)-(unRobot mundo left + unRobot mundo extent x))abs <= unaLongitud) 
"Se extiende al este"
ifTrue: [ self extenderAlEste: unaLongitud.
		self robot reasignarRobot . ].! !

!Mundo methodsFor: 'extenciones' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
ampliarParaMoverEnY: unaLongitud delRobot: unRobot

((unRobot top - unRobot mundo top)abs <= unaLongitud) 
"Se extiende al norte"
ifTrue: [ self extenderAlNorte:  unaLongitud.
		self robot reasignarRobot  .] .

(((unRobot top + unRobot extent y)-(unRobot mundo top + unRobot mundo extent y))abs <= unaLongitud)
"Se extiende al sur"
ifTrue: [ self extenderAlSur:  unaLongitud.
		self robot reasignarRobot  .]! !

!Mundo methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
caminos
	^ caminos! !

!Mundo methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
caminos: anObject
	caminos := anObject! !

!Mundo methodsFor: 'caminos' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
dibujarLineaDesde: ptoInicio conLongitud: unaLongitud conInclinacion: unAngulo

|ptoActual longEnX longEnY puntoDibujado|

ptoActual:= ptoInicio.
longEnX:= self robot angle cos * 2.
longEnY:= self robot angle sin * 2.


(unaLongitud // 2) timesRepeat: 
[ 	puntoDibujado:= self dibujarPunto: ptoActual.
	self addMorph: puntoDibujado.
	ptoActual:= (ptoActual x + longEnX) @ (ptoActual y - longEnY).]

! !

!Mundo methodsFor: 'caminos' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
dibujarPunto: posicion

|nuevoPunto|

nuevoPunto:= Morph new.
nuevoPunto extent: 2@2.
nuevoPunto position: posicion.
self caminos add: nuevoPunto.
^ nuevoPunto openInWorld .! !

!Mundo methodsFor: 'extenciones' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
extenderAlEste: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x + (cuadriculasAExtender * 70)) @ (self extent y ).
nuevoMundo position: self position.
self actualizarCaminos: nuevoMundo.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
extenderAlNorte: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x) @ (self extent y + (cuadriculasAExtender * 70)).
nuevoMundo position: (self position x) @ (self position y - (cuadriculasAExtender * 70)).
self actualizarCaminos: nuevoMundo.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
extenderAlOeste: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x + (cuadriculasAExtender * 70)) @ (self extent y ).
nuevoMundo position: (self position x - (cuadriculasAExtender * 70) @ (self position y)).
self actualizarCaminos: nuevoMundo.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'extenciones' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
extenderAlSur: unaLongitud

|cuadriculasAExtender nuevoMundo|

cuadriculasAExtender:= (unaLongitud // 70 ) + 1.
nuevoMundo:= Mundo crearMundo: (self extent x) @ (self extent y + (cuadriculasAExtender * 70)).
nuevoMundo position: self position.
self actualizarCaminos: nuevoMundo.
nuevoMundo robot: self robot.
self robot mundo: nuevoMundo.
self delete.
^ nuevoMundo openInWorld .
! !

!Mundo methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
robot
	^ robot! !

!Mundo methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
robot: anObject
	robot := anObject! !

BorderedMorph subclass: #CuadriculaDeMundo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!CuadriculaDeMundo class methodsFor: 'crear instancia' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
crearCuadriculaDeMundo

|cuadricula|
cuadricula:= BorderedMorph new.
cuadricula extent: 70@70.
cuadricula borderWidth: 1.
cuadricula color: (Color black alpha: 0).
^ cuadricula openInWorld .! !

Workspace subclass: #PharoBotWorkspaceAdaptor
	instanceVariableNames: 'workspace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!PharoBotWorkspaceAdaptor commentStamp: '<historical>' prior: 0!
I adapt the Pharo workspace in order to add more features used in PharoBot, such as notifying changes, adding variables, and so on.!

!PharoBotWorkspaceAdaptor methodsFor: 'accessing' stamp: 'NahuelGarbezza 7/14/2012 19:39'!
workspace

	^workspace! !

!PharoBotWorkspaceAdaptor methodsFor: 'accessing' stamp: 'NahuelGarbezza 7/14/2012 19:39'!
workspace: aPharoBotWorkspace

	workspace := aPharoBotWorkspace! !

Object subclass: #EstadoDelRobot
	instanceVariableNames: 'robot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!EstadoDelRobot class methodsFor: 'crear instancia' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
"Luego de crear un EstadoDelRobot  hay que mandarle el mensaje inicializarEstadoEnRobot "

crearEstado: unRobot

|estado|

estado:= self new.
estado robot: unRobot.
^ estado.! !

!EstadoDelRobot methodsFor: 'inicializacion' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
inicializarEstadoEnRobot

"El robot comienza con un EsadoActual = Estado_PincelArriba"
self subclassResponsibility .! !

!EstadoDelRobot methodsFor: 'movimientos' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
mover: unaLongitud

|movimientoEnX movimientoEnY|

(self robot bateria carga < unaLongitud)
ifTrue: [self error: 'Debe recargar la bateria para realizar el movimiento'].

movimientoEnX:= self robot angle cos * unaLongitud.
movimientoEnY:= self robot angle sin * unaLongitud.

"Movimiento en x"

self robot position: (self robot position x + movimientoEnX) @ (self robot position y).
self robot mundo ampliarParaMoverEnX: movimientoEnX abs delRobot: self robot.

"Movimiento en y"

self robot position: (self robot position x) @ (self robot position y - movimientoEnY).
self robot mundo ampliarParaMoverEnY: movimientoEnY abs delRobot: self robot.
"Actualizo ultima posicion"

self robot ultimaPosicion: self robot position .

self robot bateria carga: self robot bateria carga - unaLongitud.

! !

!EstadoDelRobot methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelAbajo

self subclassResponsibility .! !

!EstadoDelRobot methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelArriba

self subclassResponsibility .! !

!EstadoDelRobot methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
robot
	^ robot! !

!EstadoDelRobot methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
robot: anObject
	robot := anObject! !

EstadoDelRobot subclass: #Estado_PincelAbajo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!Estado_PincelAbajo methodsFor: 'inicializacion' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
inicializarEstadoEnRobot 

self robot estado_pincelAbajo: self.! !

!Estado_PincelAbajo methodsFor: 'movimientos' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
mover: unaLongitud

|posicionInicial|

posicionInicial:= self robot ultimaPosicion.

super mover: unaLongitud.
self robot mundo dibujarLineaDesde: posicionInicial conLongitud: unaLongitud conInclinacion: self robot angle.! !

!Estado_PincelAbajo methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelAbajo 

^ true.! !

!Estado_PincelAbajo methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelArriba 

^ false.! !

EstadoDelRobot subclass: #Estado_PincelArriba
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!Estado_PincelArriba methodsFor: 'inicializacion' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
inicializarEstadoEnRobot 

self robot estado_pincelArriba: self.
self robot estado_pincelActual: self.! !

!Estado_PincelArriba methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelAbajo  

^ false.! !

!Estado_PincelArriba methodsFor: 'pincel' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
pincelArriba 

^ true.! !

Object subclass: #PharoBotUI
	instanceVariableNames: 'tabGroup builder environment'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!PharoBotUI class methodsFor: 'world menu' stamp: 'NahuelGarbezza 7/14/2012 19:54'!
menuCommandOn: aBuilder
	<worldMenu>

	(aBuilder item: #PharoBot)
		order: 4;
		target: self.
	
	(aBuilder group: #PharoBotPracticas)
		parent: #PharoBot;
		with: [
			(aBuilder item: #'Practica 1')
				action:[ PharoBotUIWithObjects open ].
			(aBuilder item: #'Practica 2')
				action: [ PharoBotUIWithClasses open ]].! !

!PharoBotUI class methodsFor: 'ui opening' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
open

	^self new open! !

!PharoBotUI methodsFor: 'ui building' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildCodeBrowserLabel

	^builder newRow: {
		builder newImage: ThemeIcons projectIcon.
		builder newLabel: 'Codigo'.
	}! !

!PharoBotUI methodsFor: 'ui building' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildCodeBrowserPanel

	|browser|
	browser := GLMTabulator new.
	self buildLayoutFor: browser.
	self buildTransitionsFor: browser.
	^self startBrowser: browser.! !

!PharoBotUI methodsFor: 'ui building' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildLayoutFor: browser

	self subclassResponsibility! !

!PharoBotUI methodsFor: 'ui building' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildMainButtons

	^builder newRow: {
		builder
			newButtonFor: self
			action: #saveImage
			label: 'Guardar Ambiente'
			help: 'Guarda el estado del ambiente para ser cargado luego'.
		builder
			newButtonFor: self
			action: #quit
			label: 'Salir'
			help: 'Sale del ambiente'.
	}.! !

!PharoBotUI methodsFor: 'ui building' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildMainPanel

	^(builder := UITheme builder) newColumn: {
		self buildMainTabGroup.
		self buildMainButtons.
	}.! !

!PharoBotUI methodsFor: 'ui building' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildMainTabGroup

	^builder newTabGroup: {
		self buildWorkspaceLabel -> self buildWorkspacePanel.
		self buildCodeBrowserLabel -> self buildCodeBrowserPanel.
	}.! !

!PharoBotUI methodsFor: 'ui building' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildTransitionsFor: browser

	self subclassResponsibility! !

!PharoBotUI methodsFor: 'ui building' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildWorkspaceLabel

	^builder newRow: {
		builder newImage: ThemeIcons objectsIcon.
		builder newLabel: 'Pruebas'.
	}! !

!PharoBotUI methodsFor: 'ui building' stamp: 'NahuelGarbezza 7/26/2012 13:11'!
buildWorkspacePanel

	|browser|
	browser := GLMTabulator new.
	browser
		row: #world span: 6;
		row: [ :row | row
			column: #workspaces span: 2;
			column: #currentWorkspace span: 5;
			column: #variables span: 3.
		] span: 4.
	
	browser transmit to: #world; andShow: [ :p |
		p morph display: [ self buildWorldArea ]
	].
	
	browser transmit to: #workspaces; andShow: [ :p |
		p list
			title: 'Workspaces';
			display: #workspaces;
			act: [ :pl | self createNewWorkspace ] icon: GLMUIThemeExtraIcons glamorousAdd entitled: 'Nuevo Workspace';
			selectionAct: [ :w | nil ] entitled: 'Eliminar Workspace'
	].
	
	browser transmit from: #workspaces; to: #currentWorkspace; andShow: [ :p |
		p morph display: [ :pharoBotWorkspace | PharoBotWorkspaceAdaptor new workspace: pharoBotWorkspace; buildTextMorph ]
	].
	
	browser transmit
		from: #workspaces;
		to: #variables;
		andShow: [ :p | p table
			display: [ :w | w variableBindings associations ];
			column: 'Variable' evaluated: #key;
			column: 'Valor' evaluated: [ :a | a value printString ];
			selectionAct: [ :t | t selection value inspect ] on: $i entitled: 'Inspect'
		].
		
	^self startBrowser: browser! !

!PharoBotUI methodsFor: 'ui building' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildWorldArea

	"TODO eliminar codigo de prueba"
	| world laBateria elRobot elMundo sp |
	world := Mundo crearMundo: 560@560.
	laBateria:= Bateria crearBateriaConCargaMaxima: 1000.
	elRobot:= RobotMorph crearRobotConMundo: world conBateria: laBateria. 
	elRobot inicializarRobot.
	sp := ScrollPane new.
	sp scroller addMorph: world.
	^sp! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
createNewWorkspace

	self shouldBeImplemented.! !

!PharoBotUI methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
environment

	^environment! !

!PharoBotUI methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
environmentClass

	self subclassResponsibility! !

!PharoBotUI methodsFor: 'ui opening' stamp: 'NahuelGarbezza 7/14/2012 19:34'!
open

	environment := self environmentClass new.
	^(self buildMainPanel openInWindowLabeled: 'PharoBot') fullscreen; yourself! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
quit

	self shouldBeImplemented! !

!PharoBotUI methodsFor: 'actions' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
saveImage

	self shouldBeImplemented! !

!PharoBotUI methodsFor: 'private' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
startBrowser: browser

	^(browser startOn: self environment) renderGlamorouslyOn: GLMMorphicRenderer new! !

PharoBotUI subclass: #PharoBotUIWithClasses
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!PharoBotUIWithClasses methodsFor: 'ui building' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildLayoutFor: browser
	
	browser
		row: [ :row | row column: #classes span: 30; column: #methods span: 70 ];
		row: #code.! !

!PharoBotUIWithClasses methodsFor: 'ui building' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildTransitionsFor: browser
	
	browser transmit to: #classes; andShow: [ :p |
		p list
			title: 'Clases'; display: #classes;
			act: [ self createNewClass ] icon: GLMUIThemeExtraIcons glamorousAdd entitled: 'Nueva Clase';
			selectionAct: [ :class | self removeClass: class ] icon: GLMUIThemeExtraIcons glamorousRemove entitled: 'Eliminar Clase';
			act: [ self importClass ] icon: GLMUIThemeExtraIcons glamorousUp entitled: 'Importar Clase';
			selectionAct: [ :class | self exportClass: class ] icon: GLMUIThemeExtraIcons glamorousDown entitled: 'Exportar Clase'
	].
	browser transmit from: #classes; to: #methods; andShow: [ :p |
		p list
			title: 'Metodos de instancia'; display: [ :class | class selectors ];
			act: [ :m | nil ] icon: GLMUIThemeExtraIcons glamorousAdd entitled: 'Agregar metodo';
			selectionAct: [ :m | nil ] icon: GLMUIThemeExtraIcons glamorousRemove entitled: 'Eliminar metodo'.
		p list
			title: 'Metodos de clase'; display: [ :class | class class selectors ];
			act: [ :m | nil ] icon: GLMUIThemeExtraIcons glamorousAdd entitled: 'Agregar metodo';
			selectionAct: [ :m | nil ] icon: GLMUIThemeExtraIcons glamorousRemove entitled: 'Eliminar metodo'.
	].
	browser transmit
		from: #classes;
		from: #methods;
		to: #code;
		andShow: [ :p | 
			p smalltalkCode
				display: [ :class :selector |
					[ class >> selector ] on: Error do: [ class class >> selector ]
				];
				title: 'Implementacion';
				smalltalkClass: [ :class :selector | class ];
				act: [ :text | text inspect ] icon: GLMUIThemeExtraIcons glamorousCancel on: $l entitled: 'Deshacer cambios';
				act: [ :text | text inspect ] icon: GLMUIThemeExtraIcons glamorousAccept on: $s entitled: 'Guardar metodo'.
		].! !

!PharoBotUIWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
createNewClass

	self shouldBeImplemented.! !

!PharoBotUIWithClasses methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
environmentClass

	^PharoBotEnvironmentWithClasses! !

!PharoBotUIWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
exportClass: aClass

	self shouldBeImplemented! !

!PharoBotUIWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
importClass

	self shouldBeImplemented! !

!PharoBotUIWithClasses methodsFor: 'actions' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
removeClass: aClass

	self shouldBeImplemented.! !

PharoBotUI subclass: #PharoBotUIWithObjects
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PharoBot-UI'!

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
buildLayoutFor: browser

	browser row: #instanceMethods span: 4; row: #code span: 6! !

!PharoBotUIWithObjects methodsFor: 'ui building' stamp: 'NahuelGarbezza 7/18/2012 17:15'!
buildTransitionsFor: browser

	browser transmit to: #instanceMethods; andShow: [ :p |
		p list
			title: 'Metodos';
			display: #robotMethods;
			selectionAct: [ :m | self removeInstanceMethod: m onClass: PharoBotGlobalEnvironment instance robotClass ]
			icon: GLMUIThemeExtraIcons glamorousRemove
			entitled: 'Eliminar metodo'.
	].

	browser transmit from: #instanceMethods; to: #code; andShow: [ :p | 
		p smalltalkCode
			display: [ :selector | PharoBotGlobalEnvironment instance robotClass >> selector ];
			title: 'Implementacion';
			smalltalkClass: PharoBotGlobalEnvironment instance robotClass;
			act: [ :text | text inspect ]
			icon: GLMUIThemeExtraIcons glamorousCancel
			on: $l entitled: 'Cancelar';
			act: [ :text | text inspect ]
			icon: GLMUIThemeExtraIcons glamorousAccept
			on: $s entitled: 'Aceptar'.
		].! !

!PharoBotUIWithObjects methodsFor: 'accessing' stamp: 'NahuelGarbezza 4/8/2012 12:34:30'!
environmentClass

	^PharoBotEnvironmentWithObjects! !
